; customizable function keys
alias fkeys {
  _opendlg basic
  .timer 1 0 did -c basic 106
}
; $fkey(command) - $fkey(/resend) would return the function key for /resend
alias fkey {
  var %f = $readini($fkeys.dat,$remove($1,/),fkey)
  var %f2 = $readini($fkeys.dat,$1,fkey)
  return $iif(%f,%f,$iif(%f2,$switchcase(%f2),$upper($1)))
}
alias -l switchcase {
  if (c* iswm $1) return Ctrl+ $+ $upper($mid($1,2))
  if (s* iswm $1) return Shift+ $+ $upper($mid($1,2))
  return $upper($1)
}
; $func(fkey) - $func(F1) would return the command used for F1
alias func return $readini($fkeys.dat,$1,com)
alias fcom {
  var %i = 1, %array = cf? cf?? f? sf? sf?? ctrl* shift*
  while ($gettok(%array,%i,32)) {
    if ($ifmatch iswm $fkey($1)) return Press
    inc %i
  }
  return Type
}
alias fdisp return $fcom($1) $fkey($1)
; $read(filename, [ntsw], [matchtext], [N])
; /fset <f-key> com <command>
alias fset {
  if (($3) && ($3 != -Empty-)) {
    writeini -n $fkeys.dat $1-
    if ($read($fkeys.txt,ns,$3)) writeini -n $fkeys.dat $3 fkey $1
  }
  else {
    if ($func($1)) remini $fkeys.dat $ifmatch
    if ($ini($fkeys.dat,$1)) remini $fkeys.dat $1
  }
}
alias -l fm {
  if ($2 == -Empty-) did -u basic $1
  elseif ($didwm(basic,$1,$2,1)) did -c basic $1 $ifmatch
}
on *:dialog:basic:sclick:99:{
  did -u $dname 139,138,137
  var %f = $did(99,$did(99).sel)
  if (%f == f4) did -b $dname 136,137
  elseif (!$did(136).enabled) did -e $dname 136,137

  did -o $dname 134 1 %f
  did -o $dname 135 1 $+(Shift+,%f)
  did -o $dname 136 1 $+(Ctrl+,%f)

  if ($($+(%,sys.fkeytmp.,%f),2)) fm 139 $ifmatch
  elseif ($func(%f)) fm 139 $ifmatch
  if ($($+(%,sys.fkeytmp.Ctrl+,%f),2)) fm 137 $ifmatch
  elseif ($($+(%,sys.fkeytmp.Shift+,%f),2)) fm 138 $ifmatch
  elseif ($func($+(s,%f))) { if ($didwm(138,$ifmatch,1)) did -c $dname 138 $ifmatch }
  elseif ($func($+(c,%f))) { if ($didwm(137,$ifmatch,1)) did -c $dname 137 $ifmatch }
}
on *:dialog:basic:sclick:102:{
  var %text = $gettok($did(102,$did(102).sel),1,32)
  if ($readini($fkeys.txt,description,%text)) {
    did -o $dname 141 1 $crlf $+ $did(102,$did(102).sel) $str($crlf,2) $+ $ifmatch
  }
  elseif ($did(102).sel) did -o $dname 141 1 $crlf $+ $did(102,$ifmatch) $+ $str($crlf,2) $+ No description available
}
on *:dialog:basic:init:*:{
  var %com = loadbuf -otcommands $dname, %f = $fkeys.txt
  didtok -a $dname 99 32 F1 F2 F3 F4 F5 F6 F7 F8 F9 F10 F11 F12
  %com 137 %f
  %com 138 %f
  %com 139 %f
  %com 102 %f
  did -a $dname 137,138,139 -Empty-
}
alias -l fsettmp {
  var %n = basic
  if ($did(%n,$1,$did(%n,$1).sel)) set %sys.fkeytmp. $+ $did(%n,$2).text $ifmatch
  else unset $+(%,sys.fkeytmp.,$did(%n,$2).text)
}
alias -l _openfkey { if (!$dialog(fkey)) !.echo -q $dialog(fkey,fkey,-4) }
on *:dialog:basic:sclick:101:.timer -m 1 1 _openfkey
on *:dialog:basic:sclick:104:{
  if ($did(102).sel) {
    var %l = $ifmatch, %c = $did(102,%l)
    if ($input(Are you sure you want to remove %c from the commands list?,256,Remove command)) {
      set %sys.fkeytmp.del $addtok(%sys.fkeytmp.del,%c,1)
      did -d basic 102 %l
      did -o basic 141 1 Select a command from the list to view its description.
    }
  }
}
on *:dialog:basic:sclick:139:fsettmp 139 134
on *:dialog:basic:sclick:138:fsettmp 138 135
on *:dialog:basic:sclick:137:fsettmp 137 136
on *:dialog:basic:sclick:3:{
  var %i = 1
  while (%i <= 12) {
    if ($($+(%,sys.fkeytmp.,F,%i),2)) fset $+(F,%i) com $ifmatch
    if ($($+(%,sys.fkeytmp.,Ctrl+F,%i),2)) fset $+(cF,%i) com $ifmatch
    if ($($+(%,sys.fkeytmp.,Shift+F,%i),2)) fset $+(sF,%i) com $ifmatch
    inc %i
  }
  if (%sys.fkeytmp.del) {
    var %i = 1, %tmp, %f = $fkeys.txt
    while ($gettok(%sys.fkeytmp.del,%i,1)) {
      %tmp = $read(%f,ns,$ifmatch)
      if ($readn) write $+(-dl,$ifmatch) %f
      if ($readini(%f,n,description,%tmp)) remini %f description %tmp
      inc %i
    }
    return
    ; another lame workaround because $read(blah,ns,string) is broken
    var %w = @_broken$read $+ $ticks, %f = $fkeys.txt
    window -hsl %w
    loadbuf -tcommands %w %f
    iline %w 1 [commands]
    remini %f commands
    var %i = 1, %s
    while ($gettok(%sys.fkeytmp.del,%i,1)) {
      %s = $ifmatch
      if ($fline(%w,%s,1)) {
        dline %w $ifmatch
        if ($readini(%f,n,description,%s)) remini %f description %s
      }
      inc %i
    }
    savebuf -a %w %f
    window -c %w
  }
  unset %sys.fkeytmp.*
}
on *:dialog:basic:sclick:4:unset %sys.fkeytmp.*

alias F1 {
  if ($func(F1)) $ifmatch
  else help
}
alias F2  $func(F2)
alias F3  $func(F3)
alias F4  $func(F4)
alias F5  $func(F5)
alias F6  $func(F6)
alias F7  $func(F7)
alias F8  $func(F8)
alias F9  $func(F9)
alias F10 $func(F10)
alias F11 $func(F11)
alias F12 $func(F12)
; shift
alias sF1  $func(sF1)
alias sF2  $func(sF2)
alias sF3  $func(sF3)
alias sF4  $func(sF4)
alias sF5  $func(sF5)
alias sF6  $func(sF6)
alias sF7  $func(sF7)
alias sF8  $func(sF8)
alias sF9  $func(sF9)
alias sF10 $func(sF10)
alias sF11 $func(sF11)
alias sF12 $func(sF12)
; ctrl
alias cF1  $func(cF1)
alias cF2  $func(cF2)
alias cF3  $func(cF3)
alias cF5  $func(cF5)
alias cF6  $func(cF6)
alias cF7  $func(cF7)
alias cF8  $func(cF8)
alias cF9  $func(cF9)
alias cF10 $func(cF10)
alias cF11 $func(cF11)
alias cF12 $func(cF12)

dialog -l fkey {
  title "Function key commands editor"
  size -1 -1 171 41
  option dbu
  button "&Ok", 1, 52 28 32 12, ok
  button "&Cancel", 2, 86 28 32 12, cancel
  text "Command:", 3, 2 5 35 8
  text "Description:", 4, 2 15 35 8
  edit "", 5, 39 3 130 11, autohs
  edit "", 6, 39 15 130 11, autohs
}
on *:dialog:fkey:init:*:did -cfe fkey 5
on *:dialog:fkey:sclick:2:_showdlg basic
on *:dialog:fkey:sclick:1:{
  if ($did(5) != $null) {
    var %w = @_ $+ $ticks, %com = $iif(/* !iswm $did(5),$+(/,$did(5)),$did(5))
    window -hl %w 1 1 1 1
    if ($_isfile($fkeys.txt)) {
      aline %w [commands]
      loadbuf -tcommands %w $ifmatch
      remini $fkeys.txt commands
    }
    aline %w %com
    savebuf -a %w $fkeys.txt
    window -c %w
    if ($did(6) != $null) writeini $fkeys.txt description %com $did(6)
    if ($dialog(basic)) {
      did -r basic 102
      loadbuf -otcommands basic 102 $fkeys.txt
    }
  }
  _showdlg basic
}
; eof
